{  Demonstriert wird in der Prozedur
   Sortieren durch Einsortieren
   Einfachster Fall: Jeweils eine Hlfte wird geordnet mit Bubblesort.
                     Anschliessend wird einsortiert
   Bubblesort: siehe extra Projekt.
------------------------------------------------------------
   Effizienz ist von der Ordnung((n/2)^2)
   ========================================
   (zu reinem Bubblesort: nicht viel gewonnen)
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    BFuellen: TButton;
    BOrdnen: TButton;
    EAnzahl: TEdit;
    Label1: TLabel;
    BSchliessen: TButton;
    Memo3: TMemo;
    procedure BFuellenClick(Sender: TObject);
    procedure BOrdnenClick(Sender: TObject);
    procedure BSchliessenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tausche(var a,b:real);
  var x:real;
begin
  x:=a;
  a:=b;
  b:=x;
end;

//Noch muss ein Teil sortiert werden. Primitv mit Bubblesort
procedure bubblesort(var aa:array of real; n1,n2:integer); //sortiert von n1 bis n2
  var i:integer;
      fertig: Boolean;
begin
  repeat
    fertig:=true;
    for i:=n1 to n2-1 do Begin
      if aa[i]>aa[i+1] then BEgin
        tausche(aa[i],aa[i+1]);
        fertig:=false;
      ENd;
    End;
  until fertig;
end;


//Die folgende Prozedur bleibt beim rekursiven Programmieren brig
procedure Einsortieren(var aa:array of real; n1,m,n2:integer);
  //aa[n1]<=aa[n1+1]<=..<=aa[m] aa[m+1]<=aa[m+2]<=...<=aa[n2]
  //  i1------------------>     i2---------------------->
  //  k---------- fllt Hilfsfeld----------------------->
  var i1,i2,k,n:integer;
      hilf: array of real;
begin
  n:=n2-n1+1; //Anzahl von aa[n1] ... aa[n2]
  setlength(hilf,n); //Platz fr hilf[0] ... hilf[n-1]
  i1:=n1;
  i2:=m+1;
  for k:=0 to n-1 do //i1>m und i2>n2 auch abfangen!
    if (i1>m) or ((i2<=n2) and (aa[i1]>aa[i2])) then Begin
      hilf[k]:=aa[i2];
      inc(i2);
    End else  Begin
      hilf[k]:=aa[i1];
      inc(i1);
    End;
  for k:=0 to n-1 do aa[n1+k]:=hilf[k];
end;

procedure zeige(mm:Tmemo; aa:array of real);
  var i:integer;
begin
  mm.Lines.Clear;
  for i:=0 to length(aa)-1 do mm.Lines.Add(FloatToStr(aa[i]));
end;

procedure sortieren(var aa:array of real);
  var n,mitte:integer;
begin
  n:=length(aa);             //z.B. n=10
  mitte:=n div 2;            //z.B. mitte:=5
  bubblesort(aa,0,mitte-1);  //ordnen von 0 bis 4 (5 Elemente)
  bubblesort(aa,mitte,n-1);  //Ordnen von 5 bis 9 (5 Elemente)
  //Zu Testzwecken
  zeige(form1.memo2,aa);
  Einsortieren(aa,0,mitte-1,n-1);
end;

procedure TForm1.BFuellenClick(Sender: TObject);
  var i,anzahl:integer;
      aa:array of real;
begin
  anzahl:=strToInt(EAnzahl.text);
  setlength(aa,anzahl);
  for i:=0 to Anzahl-1 do aa[i]:=i+1;
  //Durcheinanderwirbeln
  randomize;
  for i:=0 to Anzahl-1 do tausche(aa[i],aa[random(Anzahl)]);
  zeige(memo1,aa);
end;

procedure TForm1.BOrdnenClick(Sender: TObject);
  var aa:array of real;
     n,i:integer;
begin
  n:=strToInt(EAnzahl.text);
  setlength(aa,n); //n Pltze fr aa[0] bis aa[n-1] reserviert
  for i:=0 to n-1 do aa[i]:=StrToFloat(memo1.lines[i]);
  sortieren(aa);
  zeige(memo3,aa);
end;

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  close
end;

end.
